/*!
 * 一些常用的常量放在这里
 * @Zeego Tech
 */

// 系统设置常量
var AppBaseConfig = {
	appDomain: "www.wf-chn.com",
	apiURI: "http://webapi.wf-chn.com/V2/",
	mainPath: "http://v2.wf-chn.com/",
	imgPath: "http://v2.wf-chn.com/UploadImg/products/source/",
//	imgPath360: "http://www.wf-chn.com/UploadImg/products/360/",
//	imgPath640: "http://www.wf-chn.com/UploadImg/products/640/",
	wxSitePath: "http://mobile.wf-chn.com/",
	version: "2.0.5"
};
//用于切换APP与微信端
var PlatformInfo = {
	name: "app"
	//name: "web"
}

// 用于本地存储的key
var StorageKeys = {
	UserInfo: "WF_UserInfo",
	IndexDataCache: "WF_Index_Data_Cache",
	OrderSubmit: "WF_Order_Submit",
	ContractSign: "WF_ContractSign",
	Temp: "WF_TEMP",
	Nid:"NEW_ID",
	Pid:"PRODUCT_ID",
	wxUserInfo:"WX_UserInfo",
	mesArray:"messageArray",
	tempPaymentInfo:"WF_PaymentInfo",
	tempCouponInfo:"WF_TempCouponInfo",
	BankInfo:"WF_BankInfo",
	H8ValidObject:"WF_H8Object"
};

// 支付方式的枚举字符串
function _GetPaymentStr(payment){
	var paytype = parseInt(payment);
	switch(paytype){
		case 1:
			return "支付宝支付";
			break;
		case 5:
			return "微信支付";
			break;
		case 4:
			return "货到付款";
			break;
		case 6:
			return "礼品卡支付";
			break;
		default:
			return "未知";
			break;
	}
}

// 支付状态的枚举字符串
function _GetIsPayStr(ispay){
	var ispayType = parseInt(ispay);
	switch(ispayType){
		case 0:
			return "未付款";
			break;
		case 1:
			return "已付款";
			break;
		case 2:
			return "已退款";
			break;
		default:
			return "未知";
			break;
	}
}

// 订单状态的枚举字符串
function _GetOrderStateStr(state){
	var stateType = parseInt(state);
	switch(stateType){
		case 0:
			return "等待确认";
			break;
		case 1:
			return "已确认";
			break;
		case 2:
			return "已取消";
			break;
		case 3:
			return "无效";
			break;
		case 4:
			return "退货";
			break;
		case 5:
			return "交易完成";
			break;
		case 6:
			return "已移除";
			break;
		case 7:
			return "安装确认";
			break;
		case 8:
			return "已安装";
			break;
		default:
			return "未知";
			break;
	}
}

// 订单发货状态的枚举
function _GetIsSendStr(issend){
	var issendType = parseInt(issend);
	switch(issendType){
		case 0:
			return "等待分配";
			break;
		case 1:
			return "配货中";
			break;
		case 2:
			return "安装工派单中";
			break;
		case 3:
			return "已派单";
			break;
		case 4:
			return "安装确认";
			break;
		case 5:
			return "退货中";
			break;
		case 6:
			return "已退货";
			break;
		case 7:
			return "缺货等待中";
			break;
		case 8:
			return "售后换货中";
			break;
		case 9:
			return "更换滤芯";
			break;
		default:
			return "未知";
			break;
	}
}
//设备状态的枚举
function _GetDeviceStatusStr(status){
	var status = parseInt(status);
	switch(status){
		case 1:
			return "正常";
			break;
		case 2:
			return "报修中";
			break;
		case 3:
			return "合同过期";
			break;
		case 4:
			return "升级中";
			break;
		case 5:
			return "已回收";
			break;
		case 6:
			return "失效";
			break;
		default:
			return "未知";
			break;
	}
}
//工单类型枚举
function _GetServiceRequestType(type){
	var type = parseInt(type);
	switch(type){
		case 1:
			return "维修工单";
			break;
		case 2:
			return "滤芯更换工单";
			break;
		case 3:
			return "水质检测工单";
			break;
		case 4:
			return "合约终止工单";
			break;
		case 5:
			return "安装工单";
			break;
		default:
			return "未知";
			break;
	}
}
//工单状态的枚举
function _GetRequestStatusStr(status){
	var status = parseInt(status);
	switch(status){
		case 0:
			return "草稿";
			break;
		case 1:
			return "未处理";
			break;
		case 2:
			return "已确认";
			break;
		case 3:
			return "已派单";
			break;
		case 4:
			return "处理中";
			break;
		case 5:
			return "待评价";
			break;
		case 6:
			return "已完成";
			break;
		case 10:
			return "已取消";
			break;	
		default:
			return "未知";
			break;
	}
}

function _getContractStatus(status){
	var status = parseInt(status);
	switch(status){
		case 0:
			return "草稿";
			break;
		case 1:
			return "未确认";
			break;
		case 2:
			return "已确认";
			break;
		case 3:
			return "过期";
			break;
		case 4:
			return "作废";
			break;
		default:
			return "未知";
			break;
	}
}

//附加的一个执行逻辑，只有微信版才有这个
if(PlatformInfo.name!="app"){
	var oHead = document.getElementsByTagName('HEAD').item(0);
	var oScript= document.createElement("script");
	oScript.type = "text/javascript";
	oScript.src="http://res.wx.qq.com/open/js/jweixin-1.0.0.js";
	oHead.appendChild(oScript); 
}

